



clear all; close all; clc;
global R
global L
global ref_inputname1
global trial_inputname1
global inputname2R
global inputname2L
global Angles;
global AnglesS;
global P;
global PalmarArch;


%FILES MUST BE IN CORRECT PATH Subjects/SujetoX/RepeticionX
%JUST ENTER THE OPTIONS REQUIRED IN USER SETTINGS
%YOU WILL GET 2 VARIABLES STRUCTURE AND 2 EXCEL(excel files names can be
%changed)
%Angles.mat & Angles.xlsx  for angles obtained cut & filtered when selected
%AnglesS.mat & AnglesS.xlsx  if splitted, if not, is like Angles.mat with
%only part=1.



%                            INPUT DATA INFO
%__________________________________________________________________________
% Structure of the cyberglove text file (contents of each column) must be 
% as follow:
% 1:time 2:CMC1_roll 3:MCP1 4:IP1 5:Abd_1-2
% 6:MCP2 7:PIP2 8:DIP2 9:--
% 10:MCP3 11:PIP3 12:DIP3 13:Abd_2-3
% 14:MCP4 15:PIP4 16:DIP4 17:Abd_3-4
% 18:MCP5 19:PIP5 20:DIP5 21:Abd_4-5
% 22:Palm_arch 23:Wrist_F 24:Wrist_A 25:--


%                            USER SETTINGS
%__________________________________________________________________________

% GLOVES ------------------------------------------------------------------

R=1; % Right glove: 1=Enabled, O=Disabled 
L=1; % Left glove: 1=Enabled, O=Disabled 

%default values P=0; PalmarArch=1; precision=1;
P=0; % For Cyberglove 18 sensors: P=0 then PIPs=0 --- P=1 then DIPs from PIPs
PalmarArch=1; % PalmarArch=1 then PalmarArch --- PamarArch=0 then CMC5
%if you want CMC5 need a file HandSize.xlsx within Subjects folder with
%columns 1st subjects 2nd HB 3rd HL. IT TAKES MORE TIME OF CALCULATION
precision=1; %1 precisin milisegundos, 0 precisin segundos (necesario para trabajos antiguos)


% INPUT FILES NAMES -------------------------------------------------------

% 1st part: INPUT FILE NAME RIGHT GLOVE (Not necessary to modify if this glove is disabled)
ref_inputname1='Ensayo_'; % First part of the input file name (REF. POSTURE)
trial_inputname1='Ensayo_'; % First part of the input file name (TRIALS)

% 2nd part: INPUT FILE NAME RIGHT GLOVE (Not necessary to modify if this glove is disabled)
inputname2R='_CGR_Cable'; % Last part of the input file name

% 2nd part: INPUT FILE NAME RIGHT GLOVE (Not necessary to modify if this glove is disabled)
inputname2L='_CGL_Cable'; % Last part of the input file name


% EXIT FILE NAME ----------------------------------------------------------

filename='Angles_libre5.xlsx';% Output file name
filenameS='Angles_S_libre5.xlsx';% Output file name


% SUBJECTS-----------------------------------------------------------------

sujeto_ini=1; % Initial subject
sujeto_fin=1; % Final subject

% TRIALS ------------------------------------------------------------------

trial_ini=30; % First trial
trial_end=30; % Last trial

% REPETITIONS -------------------------------------------------------------

repeat_ini=1; % First repeat
repeat_end=1; % Last repeat

% DATA TO CUT--------------------------------------------------------------

% corte=0 Doesn't cut initial data
% corte=1 Cuts initial data while there's no movement detected
corte=1; %OJO si cortas y despus divides en archivos el hito final se te puede quedar fuera del registro.

% FREQUENCY FILTERING------------------------------------------------------

% filter=0 Don't filtering
% filter=1 Filtering
filter=1;
W=100; %adquisition frequency
Wn=5;  %cutting frequency
Wc=Wn/(W/2);

% SPLITING BY EVENTS?------------------------------------------------------
% split=0 Don't split
% split=1 Split
split=1;
%                            WORKING FOLDER
%__________________________________________________________________________
Folder_init=pwd;
Code_folder=[Folder_init,'\guant\Code']; % Code folder
path(path,Code_folder); % Adding the path of the code folder
cd guant; cd Code;


%                               FUNCTION
%__________________________________________________________________________

total=(sujeto_fin-sujeto_ini+1)*(repeat_end-repeat_ini+1)*(trial_end-trial_ini+1);
if precision==1
    ObtencionAngulos_RLprecision(sujeto_ini,sujeto_fin,repeat_ini,repeat_end,trial_ini,trial_end,total,corte,filter,Wc, split);
else
    ObtencionAngulos_RL(sujeto_ini,sujeto_fin,repeat_ini,repeat_end,trial_ini,trial_end,total,corte,filter,Wc, split);
end
%                             OUTPUT FILE 
%______________________________________________________________________
    
save('Angles.mat','Angles');
ang_calc=[];
t=1;
for s=1:total
    ang_calc(t:t-1+size(Angles(s).Tiempo,1),1)=Angles(s).Sujeto;
    ang_calc(t:t-1+size(Angles(s).Tiempo,1),2)=Angles(s).Repeticion;
    ang_calc(t:t-1+size(Angles(s).Tiempo,1),3)=Angles(s).Accion;
    ang_calc(t:t-1+size(Angles(s).Tiempo,1),4)=1:1:size(Angles(s).Tiempo,1);
    ang_calc(t:t-1+size(Angles(s).Tiempo,1),5:8)=Angles(s).Tiempo;
    ang_calc(t:t-1+size(Angles(s).Tiempo,1),9:54)=Angles(s).Angulos;
    t=size(ang_calc,1)+1
end
   
        

file_xls=filename;
if PalmarArch==1;
    header1={'SUJETO','REPETICION','AGARRE','REGISTRO','Hora','Min','Seg','mSeg','TIEMPO_R','R_CMC1_F','R_CMC1_A','R_MCP1_F','R_IP1_F','R_MCP2_F','R_MCP2_A','R_PIP2_F','R_MCP3_F','R_PIP3_F','R_MCP4_F','R_MCP4_A','R_PIP4_F','R_PalmArch_F','R_MCP5_F','R_MCP5_A','R_PIP5_F','R_DIP2','R_DIP3','R_DIP4','R_DIP5','R_WR_F','R_WR_A','TIEMPO_L','L_CMC1_F','L_CMC1_A','L_MCP1_F','L_IP1_F','L_MCP2_F','L_MCP2_A','L_PIP2_F','L_MCP3_F','L_PIP3_F','L_MCP4_F','L_MCP4_A','L_PIP4_F','L_PalmArch_F','L_MCP5_F','L_MCP5_A','L_PIP5_F','L_DIP2','L_DIP3','L_DIP4','L_DIP5','L_WR_F','L_WR_A'};
else
    header1={'SUJETO','REPETICION','AGARRE','REGISTRO','Hora','Min','Seg','mSeg','TIEMPO_R','R_CMC1_F','R_CMC1_A','R_MCP1_F','R_IP1_F','R_MCP2_F','R_MCP2_A','R_PIP2_F','R_MCP3_F','R_PIP3_F','R_MCP4_F','R_MCP4_A','R_PIP4_F','R_CMC5_F','R_MCP5_F','R_MCP5_A','R_PIP5_F','R_DIP2','R_DIP3','R_DIP4','R_DIP5','R_WR_F','R_WR_A','TIEMPO_L','L_CMC1_F','L_CMC1_A','L_MCP1_F','L_IP1_F','L_MCP2_F','L_MCP2_A','L_PIP2_F','L_MCP3_F','L_PIP3_F','L_MCP4_F','L_MCP4_A','L_PIP4_F','L_CMC5_F','L_MCP5_F','L_MCP5_A','L_PIP5_F','L_DIP2','L_DIP3','L_DIP4','L_DIP5','L_WR_F','L_WR_A'};
end
xlswrite(file_xls,header1,1,'A1');
xlswrite(file_xls,ang_calc,1,'A2');


%                             OUTPUT FILE SPLITTED
%______________________________________________________________________
    
save('AnglesS.mat','AnglesS');
ang_calc_s=[];
t=1;

totalS=size(AnglesS,2);

for s=1:totalS
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),1)=AnglesS(s).Sujeto;
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),2)=AnglesS(s).Repeticion;
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),3)=AnglesS(s).Accion;
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),4)=AnglesS(s).Parte;
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),5)=1:1:size(AnglesS(s).Tiempo,1);
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),6:9)=AnglesS(s).Tiempo;
        ang_calc_s(t:t-1+size(AnglesS(s).Tiempo,1),10:55)=AnglesS(s).Angulos;
        t=size(ang_calc_s,1)+1
end
   
        

file_xls=filenameS;
if PalmarArch==1;
    header2={'SUJETO','REPETICION','AGARRE','PARTE','REGISTRO','Hora','Min','Seg','mSeg','TIEMPO_R','R_CMC1_F','R_CMC1_A','R_MCP1_F','R_IP1_F','R_MCP2_F','R_MCP2_A','R_PIP2_F','R_MCP3_F','R_PIP3_F','R_MCP4_F','R_MCP4_A','R_PIP4_F','R_PalmArch_F','R_MCP5_F','R_MCP5_A','R_PIP5_F','R_DIP2','R_DIP3','R_DIP4','R_DIP5','R_WR_F','R_WR_A','TIEMPO_L','L_CMC1_F','L_CMC1_A','L_MCP1_F','L_IP1_F','L_MCP2_F','L_MCP2_A','L_PIP2_F','L_MCP3_F','L_PIP3_F','L_MCP4_F','L_MCP4_A','L_PIP4_F','L_PalmArch_F','L_MCP5_F','L_MCP5_A','L_PIP5_F','L_DIP2','L_DIP3','L_DIP4','L_DIP5','L_WR_F','L_WR_A'};
else
    header2={'SUJETO','REPETICION','AGARRE','PARTE','REGISTRO','Hora','Min','Seg','mSeg','TIEMPO_R','R_CMC1_F','R_CMC1_A','R_MCP1_F','R_IP1_F','R_MCP2_F','R_MCP2_A','R_PIP2_F','R_MCP3_F','R_PIP3_F','R_MCP4_F','R_MCP4_A','R_PIP4_F','R_CMC5_F','R_MCP5_F','R_MCP5_A','R_PIP5_F','R_DIP2','R_DIP3','R_DIP4','R_DIP5','R_WR_F','R_WR_A','TIEMPO_L','L_CMC1_F','L_CMC1_A','L_MCP1_F','L_IP1_F','L_MCP2_F','L_MCP2_A','L_PIP2_F','L_MCP3_F','L_PIP3_F','L_MCP4_F','L_MCP4_A','L_PIP4_F','L_CMC5_F','L_MCP5_F','L_MCP5_A','L_PIP5_F','L_DIP2','L_DIP3','L_DIP4','L_DIP5','L_WR_F','L_WR_A'};
end
xlswrite(file_xls,header2,1,'A1');
xlswrite(file_xls,ang_calc_s,1,'A2');


