function [data_short_R,data_short_L] = cut_extreme_RL3(data_ext_R,data_ext_L)

% To cut the initial and final positions

% Structure of the cyberglove text file (contents of each column):
% 1:time 2:CMC1_roll 3:MCP1 4:IP1 5:Abd_1-2
% 6:MCP2 7:PIP2 8:DIP2 9:--
% 10:MCP3 11:PIP3 12:DIP3 13:Abd_2-3
% 14:MCP4 15:PIP4 16:DIP4 17:Abd_3-4
% 18:MCP5 19:PIP5 20:DIP5 21:Abd_4-5
% 22:Palm_arch 23:Wrist_F 24:Wrist_A 25:--

global R
global L

[n m]=size(data_ext_R);

% Finds an increment up to 2.5% of the data range for each glove
MR=max(data_ext_R(:,2:m))-min(data_ext_R(:,2:m));
ML=max(data_ext_L(:,2:m))-min(data_ext_L(:,2:m));
IncR=MR*0.025;
IncL=ML*0.025;

% Initial R

if R==1
    buscando=1;
    i=2;
    while buscando
        if i<=size(data_ext_R,1)
            if sum(abs(data_ext_R(i,2:m)-data_ext_R(1,2:m))>IncR)>=1 
                buscando=0;
                id_ini_R=i-1;
                abs(data_ext_R(i,2:m)-data_ext_R(1,2:m)),IncR;
            else
                buscando=1;
                i=i+1;
            end
        else
          buscando=0;
          id_ini_R=i;
        end
    end
    
    % Final R
    buscando=1;
    i=n-1;
    while buscando
        if i>=1
            if sum(abs(data_ext_R(i,2:m)-data_ext_R(n,2:m))>IncR)>=1
                buscando=0;
                id_fin_R=i+1;
                abs(data_ext_R(i,2:m)-data_ext_R(1,2:m)),IncR;
            else
                buscando=1;
                i=i-1;
            end
        else
            buscando=0;
            id_fin_R=i;
        end
        
    end
else
    id_ini_R=(size(data_ext_R,1));
    id_fin_R=(1);
end

if L==1
    % Initial L
    buscando=1;
    i=2;
    while buscando
        if i<=size(data_ext_L,1)
            if sum(abs(data_ext_L(i,2:m)-data_ext_L(1,2:m))>IncL)>=1
                buscando=0;
                id_ini_L=i-1;
                abs(data_ext_L(i,2:m)-data_ext_L(1,2:m)),IncL;
            else
                buscando=1;
                i=i+1;
            end
        else
            buscando=0;
            id_ini_L=i;
        end
        
    end
    
    % Final L
    buscando=1;
    i=n-1;
    while buscando
        if i>=1
            if sum(abs(data_ext_L(i,2:m)-data_ext_L(n,2:m))>IncL)>=1
                buscando=0;
                id_fin_L=i+1;
                abs(data_ext_L(i,2:m)-data_ext_L(1,2:m)),IncL;
            else
                buscando=1;
                i=i-1;
            end
        else
            buscando=0;
            id_fin_L=i;
        end
        
    end
    
    
else
    id_ini_L=(size(data_ext_L,1));
    id_fin_L=(1);
end

% Determinates which is the initial instant
global punto_corte_ini
global punto_corte_fin

punto_corte_ini=min([id_ini_R id_ini_L]);

% Determinates which is the final instant

punto_corte_fin=max([id_fin_R id_fin_L]);




%
data_short_R=data_ext_R(punto_corte_ini:punto_corte_fin,:);
data_short_L=data_ext_L(punto_corte_ini:punto_corte_fin,:);

