function [anglesR,anglesL,realtime_vec]=obtain_angles_RL_abd_rel_precision(corte,Folder,FileR,FileL,RefR,RefL)
global R
global L
global P

[glove]=check_distal_values;

[right_gains,left_gains]=gains_identification; % Identifies the CyberGlove model and associate its gains

%__________________________________________________________________________
RG_PIP=right_gains(1:5);
RG_MCP_f=right_gains(6:10);
RG_MCP_a=right_gains(11:28);
RG_CMC5=right_gains(29);
RG_CMC1=right_gains(30:33);
RG_WRIST=right_gains(34:38);
RG_DIP=right_gains(39:42);

LG_PIP=left_gains(1:5);
LG_MCP_f=left_gains(6:10);
LG_MCP_a=left_gains(11:28);
LG_CMC5=left_gains(29);
LG_CMC1=left_gains(30:33);
LG_WRIST=left_gains(34:38);
LG_DIP=left_gains(39:42);

RG_abd=RG_MCP_a(1:3);
RG_abd_rel(1,:)=RG_MCP_a(4:8);
RG_abd_rel(2,:)=RG_MCP_a(9:13);
RG_abd_rel(3,:)=RG_MCP_a(14:18);

LG_abd=LG_MCP_a(1:3);
LG_abd_rel(1,:)=LG_MCP_a(4:8);
LG_abd_rel(2,:)=LG_MCP_a(9:13);
LG_abd_rel(3,:)=LG_MCP_a(14:18);
%__________________________________________________________________________

if R==1 && L==1 % Both gloves
    fileR=[Folder,'\',FileR,'.txt'];
    data_orig_R=dlmread(fileR,'',2,0);
    fileR=fopen(fileR);
    TR=textscan(fileR,'%c');
    initial_timeR=(TR{1,1}(29:36))'; % Initial time
    fclose(fileR);
    
    File_refR=[Folder,'\',RefR,'.txt'];
    data_ref_allR=dlmread(File_refR,'',2,0);
    data_refR=mean(data_ref_allR);
    
    fileL=[Folder,'\',FileL,'.txt'];
    data_orig_L=dlmread(fileL,'',2,0);
    fileL=fopen(fileL);
    TL=textscan(fileL,'%c');
    initial_timeL=(TL{1,1}(29:36))'; % Initial time
    fclose(fileL);
    
    File_refL=[Folder,'\',RefL,'.txt'];
    data_ref_allL=dlmread(File_refL,'',2,0);
    data_refL=mean(data_ref_allL);
end

if R==1 && L==0 % Only right glove
    fileR=[Folder,'\',FileR,'.txt'];
    data_orig_R=dlmread(fileR,'',2,0);
    fileR=fopen(fileR);
    TR=textscan(fileR,'%c');
    initial_timeR=(TR{1,1}(29:40))'; % Initial time
    fclose(fileR);
    
    File_refR=[Folder,'\',RefR,'.txt'];
    data_ref_allR=dlmread(File_refR,'',2,0);
    data_refR=mean(data_ref_allR);
    
    data_orig_L=zeros(size(data_orig_R,1),size(data_orig_R,2));
    data_refL=zeros(size(data_refR,1),size(data_refR,2));
    initial_timeL=0;
end

if R==0 && L==1 % Only left glove
    fileL=[Folder,'\',FileL,'.txt'];
    data_orig_L=dlmread(fileL,'',2,0);
    fileL=fopen(fileL);
    TL=textscan(fileL,'%c');
    initial_timeL=(TL{1,1}(29:36))'; % Initial time
    fclose(fileL);
    
    File_refL=[Folder,'\',RefL,'.txt'];
    data_ref_allL=dlmread(File_refL,'',2,0);
    data_refL=mean(data_ref_allL);
    
    data_orig_R=zeros(size(data_orig_L,1),size(data_orig_L,2));
    data_refR=zeros(size(data_refL,1),size(data_refL,2));
    initial_timeR=0;
end

%
%------------------------- DATA TO CUT -------------------------------

if corte==0 % Doesn't cut initial data
    dataR=data_orig_R;
    dataL=data_orig_L;
end
if corte==1
    [dataR,dataL]=cut_extreme_RL3(data_orig_R,data_orig_L); % Cuts initial data while there's no movement detected

end

% Order of angles:
% 1:CMC1_f 2:CMC1_a 3:MCP1 4:IP1 5:MCP2_f 6:MCP2_a 7:PIP2 8:MCP3_f 9:PIP3
% 10:MCP4_f 11:MCP4_a 12:PIP4 13:CMC5 14:MCP5_f 15:MCP5_a 16:PIP5
% 17:DIP2 18:DIP3 19:DIP4 20:DIP5 21:WRIST_F 22:WRIST_A

%------------------------- RIGHT ANGLES---------------------------------

anglesR=zeros(1,23);
for i=1:size(dataR,1)
    anglesR(i,1)= dataR(i,1);%Time
    anglesR(i,2)=(dataR(i,2)-data_refR(2))*RG_CMC1(1)+(dataR(i,5)-data_refR(5))*RG_CMC1(2); % CMC1_f
    anglesR(i,3)=(dataR(i,5)-data_refR(5))*RG_CMC1(3)+(dataR(i,2)-data_refR(2))*RG_CMC1(4); % CMC1_a
    anglesR(i,4)=(dataR(i,3)-data_refR(3))*RG_MCP_f(1); % MCP1
    anglesR(i,5)=(dataR(i,4)-data_refR(4))*RG_PIP(1); % IP1
    abd2R=dataR(i,13)-data_refR(13);
    mcp2R=dataR(i,6)-data_refR(6);
    mcp3R=dataR(i,10)-data_refR(10);
    anglesR(i,6)=mcp2R*RG_MCP_f(2); % MCP2_f
    anglesR(i,7)=abd2R*RG_abd(1)+RG_abd_rel(1,1)*mcp2R+RG_abd_rel(1,2)*mcp2R^2+...
        RG_abd_rel(1,3)*mcp3R+RG_abd_rel(1,4)*mcp3R^2+RG_abd_rel(1,5)*mcp2R*mcp3R; % MCP2_a
    anglesR(i,8)=(dataR(i,7)-data_refR(7))*RG_PIP(2); % PIP2
    anglesR(i,9)=mcp3R*RG_MCP_f(3); % MCP3_f
    anglesR(i,10)=(dataR(i,11)-data_refR(11))*RG_PIP(3); % PIP3
    abd4R=dataR(i,17)-data_refR(17);
    mcp4R=dataR(i,14)-data_refR(14);
    anglesR(i,11)=mcp4R*RG_MCP_f(4); % MCP4_f
    anglesR(i,12)=-(abd4R*RG_abd(2)+RG_abd_rel(2,1)*mcp3R+RG_abd_rel(2,2)*mcp3R^2+...
        RG_abd_rel(2,3)*mcp4R+RG_abd_rel(2,4)*mcp4R^2+RG_abd_rel(2,5)*mcp3R*mcp4R); % MCP4_a
    anglesR(i,13)=(dataR(i,15)-data_refR(15))*RG_PIP(4); % PIP4
    anglesR(i,14)=(dataR(i,22)-data_refR(22))*RG_CMC5; % PalmarArch
    abd5R=dataR(i,21)-data_refR(21);
    mcp5R=dataR(i,18)-data_refR(18);
    anglesR(i,15)=mcp5R*RG_MCP_f(5); % MCP5_f
    anglesR(i,16)=-(abd5R*RG_abd(3)+RG_abd_rel(3,1)*mcp4R+...
        RG_abd_rel(3,2)*mcp4R^2+RG_abd_rel(3,3)*mcp5R+RG_abd_rel(3,4)*mcp5R^2+RG_abd_rel(3,5)*mcp4R*mcp5R); % MCP5_a
    anglesR(i,17)=(dataR(i,19)-data_refR(19))*RG_PIP(5); % PIP5
    
    if glove==0 && P==1 % CyberGlove 18 sensors 
            if anglesR(i,8)<25.27
                anglesR(i,18)=0;
            else
                anglesR(i,18)=0.87*anglesR(i,8)-25.27; % DIP2
            end
            
            if anglesR(i,10)<18.33
                anglesR(i,19)=0;
            else
                anglesR(i,19)=0.79*anglesR(i,10)-18.33; % DIP3
            end
            
            if anglesR(i,13)<20.54
                anglesR(i,20)=0;
            else
                anglesR(i,20)=0.73*anglesR(i,13)-20.54; % DIP4
            end
            
            if anglesR(i,17)<12.42
                anglesR(i,21)=0;
            else
                anglesR(i,21)=0.84*anglesR(i,17)-12.42; % DIP5
            end
    else
            anglesR(i,18)=(dataR(i,8)-data_refR(8))*RG_DIP(1); % DIP2
            anglesR(i,19)=(dataR(i,12)-data_refR(12))*RG_DIP(2); % DIP3
            anglesR(i,20)=(dataR(i,16)-data_refR(16))*RG_DIP(3); % DIP4
            anglesR(i,21)=(dataR(i,20)-data_refR(20))*RG_DIP(4); % DIP5  
    end
    anglesR(i,22)=((((dataR(i,23))^2)*RG_WRIST(1)+RG_WRIST(4)))-((((data_refR(23))^2)*RG_WRIST(1)+RG_WRIST(4))); %WRIST_f
    anglesR(i,23)=(((dataR(i,24))*RG_WRIST(3))+((dataR(i,23))*RG_WRIST(2))+RG_WRIST(5))-(((data_refR(24))*RG_WRIST(3))+((data_refR(23))*RG_WRIST(2))+RG_WRIST(5)); %WRIST_A
    
    
end

%---------------------------- LEFT ANGLES------------------------

anglesL=zeros(1,23);
for i=1:size(dataL,1)
    anglesL(i,1)= dataL(i,1);%Time
    anglesL(i,2)=(dataL(i,2)-data_refL(2))*LG_CMC1(1)+(dataL(i,5)-data_refL(5))*LG_CMC1(2); % CMC1_f
    anglesL(i,3)=(dataL(i,5)-data_refL(5))*LG_CMC1(3)+(dataL(i,2)-data_refL(2))*LG_CMC1(4); % CMC1_a
    anglesL(i,4)=(dataL(i,3)-data_refL(3))*LG_MCP_f(1); % MCP1
    anglesL(i,5)=(dataL(i,4)-data_refL(4))*LG_PIP(1); % IP1
    abd2L=dataL(i,13)-data_refL(13);
    mcp2L=dataL(i,6)-data_refL(6);
    mcp3L=dataL(i,10)-data_refL(10);
    anglesL(i,6)=mcp2L*LG_MCP_f(2); % MCP2_f
    anglesL(i,7)=abd2L*LG_abd(1)+LG_abd_rel(1,1)*mcp2L+LG_abd_rel(1,2)*mcp2L^2+...
        LG_abd_rel(1,3)*mcp3L+LG_abd_rel(1,4)*mcp3L^2+LG_abd_rel(1,5)*mcp2L*mcp3L; % MCP2_a
    anglesL(i,8)=(dataL(i,7)-data_refL(7))*LG_PIP(2); % PIP2
    anglesL(i,9)=mcp3L*LG_MCP_f(3); % MCP3_f
    anglesL(i,10)=(dataL(i,11)-data_refL(11))*LG_PIP(3); % PIP3
    abd4L=dataL(i,17)-data_refL(17);
    mcp4L=dataL(i,14)-data_refL(14);
    anglesL(i,11)=mcp4L*LG_MCP_f(4); % MCP4_f
    anglesL(i,12)=-(abd4L*LG_abd(2)+LG_abd_rel(2,1)*mcp3L+LG_abd_rel(2,2)*mcp3L^2+...
        LG_abd_rel(2,3)*mcp4L+LG_abd_rel(2,4)*mcp4L^2+LG_abd_rel(2,5)*mcp3L*mcp4L); % MCP4_a
    anglesL(i,13)=(dataL(i,15)-data_refL(15))*LG_PIP(4); % PIP4
    anglesL(i,14)=(dataL(i,22)-data_refL(22))*LG_CMC5; % PalmarArch
    abd5L=dataL(i,21)-data_refL(21);
    mcp5L=dataL(i,18)-data_refL(18);
    anglesL(i,15)=mcp5L*LG_MCP_f(5); % MCP5_f
    anglesL(i,16)=-(abd5L*LG_abd(3)+LG_abd_rel(3,1)*mcp4L+...
        LG_abd_rel(3,2)*mcp4L^2+LG_abd_rel(3,3)*mcp5L+LG_abd_rel(3,4)*mcp5L^2+LG_abd_rel(3,5)*mcp4L*mcp5L); % MCP5_a
    anglesL(i,17)=(dataL(i,19)-data_refL(19))*LG_PIP(5); % PIP5
    if glove==0 && P==1 % CyberGlove 18 sensors 
            if anglesL(i,8)<25.27
                anglesL(i,18)=0;
            else
                anglesL(i,18)=0.87*anglesL(i,8)-25.27; % DIP2
            end
            
            if anglesL(i,10)<18.33
                anglesL(i,19)=0;
            else
                anglesL(i,19)=0.79*anglesL(i,10)-18.33; % DIP3
            end
            
            if anglesL(i,13)<20.54
                anglesL(i,20)=0;
            else
                anglesL(i,20)=0.73*anglesL(i,13)-20.54; % DIP4
            end
            
            if anglesL(i,17)<12.42
                anglesL(i,21)=0;
            else
                anglesL(i,21)=0.84*anglesL(i,17)-12.42; % DIP5
            end
    else
            anglesL(i,18)=(dataL(i,8)-data_refL(8))*LG_DIP(1); % DIP2
            anglesL(i,19)=(dataL(i,12)-data_refL(12))*LG_DIP(2); % DIP3
            anglesL(i,20)=(dataL(i,16)-data_refL(16))*LG_DIP(3); % DIP4
            anglesL(i,21)=(dataL(i,20)-data_refL(20))*LG_DIP(4); % DIP5  
    end
    anglesL(i,22)=((((dataL(i,23))^2)*LG_WRIST(1)+LG_WRIST(4)))-((((data_refL(23))^2)*LG_WRIST(1)+LG_WRIST(4))); %WRIST_f
    anglesL(i,23)=(((dataL(i,24))*LG_WRIST(3))+((dataL(i,23))*LG_WRIST(2))+LG_WRIST(5))-(((data_refL(24))*LG_WRIST(3))+((data_refL(23))*LG_WRIST(2))+LG_WRIST(5)); %WRIST_A
end

%                       REAL TIME STAMP
%__________________________________________________________________________

if initial_timeR~=0
    initime=initial_timeR;
else
    initime=initial_timeL;
end

if anglesL(2,1)==0
    time_col=anglesR(:,1);
else
    time_col=anglesL(:,1);
end

formatInA = 'HH:MM:SS:FFF';
if size(initime,2)>11                                                            
    A=datevec(initime,formatInA);
elseif size(initime,2)>10 && size(initime,2)<12
    initime=[initime(1:9),'0',initime(10:11)];
    A=datevec(initime,formatInA);
else
    initime=[initime(1:9),'00',initime(10)];
    A=datevec(initime,formatInA);
end

time_col_s=floor(time_col);
time_col_millis=1000*(time_col-time_col_s);

realtime_vec=zeros(size(time_col,1),4);

for i=1:size(time_col,1)
    realtime_vec(i,4)=time_col_millis(i)+(A(6)-floor(A(6)))*1000;
    realtime_vec(i,3)=time_col_s(i)+floor(A(6));
    realtime_vec(i,2)=A(5);
    realtime_vec(i,1)=A(4);
    if realtime_vec(i,4)>999
        realtime_vec(i,4)=realtime_vec(i,4)-1000;
        realtime_vec(i,3)=realtime_vec(i,3)+1;
    end
    if realtime_vec(i,3)>59
        realtime_vec(i,3)=realtime_vec(i,3)-60;
        realtime_vec(i,2)=realtime_vec(i,2)+1;
    end
    if realtime_vec(i,2)>59
        realtime_vec(i,2)=realtime_vec(i,2)-60;
        realtime_vec(i,1)=realtime_vec(i,1)+1;
    end
    
end
end



 

